namespace TwitchEventSub.Types.ChannelPoints
{
    public class ChannelPointsCustomRewardRedemption: Event
    {
        public string id { get; set; } //The redemption identifier.
        public string broadcaster_user_id { get; set; } //The requested broadcaster ID.
        public string broadcaster_user_login { get; set; } //The requested broadcaster login.
        public string broadcaster_user_name { get; set; } //The requested broadcaster display name.
        public string user_id { get; set; } //User ID of the user that redeemed the reward.
        public string user_login { get; set; } //Login of the user that redeemed the reward.
        public string user_name { get; set; } //Display name of the user that redeemed the reward.
        public string user_input { get; set; } //The user input provided. Empty string if not provided.
        public string status { get; set; } //add defaults to unfulfilled, update will be fulfilled or canceled. Possible values are unknown, unfulfilled, fulfilled, and canceled.
        public CustomChannelPointsReward reward { get; set; } //Basic information about the reward that was redeemed, at the time it was redeemed.
        public string redeemed_at { get; set; } //RFC3339 timestamp of when the reward was redeemed.
    }
    public class ChannelPointsCustomRewardRedemptionAdd : ChannelPointsCustomRewardRedemption {}
    public class ChannelPointsCustomRewardRedemptionUpdate : ChannelPointsCustomRewardRedemption {}
}