namespace TwitchEventSub.Types.ChannelPoints
{
    public class ChannelPointsCustomRewardUpdate : Event
    {
        public string id { get; set; } //The reward identifier.
        public string broadcaster_user_id { get; set; } //The requested broadcaster ID.
        public string broadcaster_user_login { get; set; } //The requested broadcaster login.
        public string broadcaster_user_name { get; set; } //The requested broadcaster display name.
        public bool is_enabled { get; set; } //Is the reward currently enabled. If false, the reward won’t show up to viewers.
        public bool is_paused { get; set; } //Is the reward currently paused. If true, viewers can’t redeem.
        public bool is_in_stock { get; set; } //Is the reward currently in stock. If false, viewers can’t redeem.
        public string title { get; set; } //The reward title.
        public int cost { get; set; } //The reward cost.
        public string prompt { get; set; } //The reward description.
        public bool is_user_input_required { get; set; } //Does the viewer need to enter information when redeeming the reward.
        public bool should_redemptions_skip_request_queue { get; set; } //Should redemptions be set to fulfilled status immediately when redeemed and skip the request queue instead of the normal unfulfilled status.
        public intSetting max_per_stream { get; set; } //Whether a maximum per stream is enabled and what the maximum is.
        public intSetting max_per_user_per_stream { get; set; } //Whether a maximum per user per stream is enabled and what the maximum is.
        public string background_color { get; set; } //Custom background color for the reward. Format: Hex with # prefix. Example: #FA1ED2.
        public Image image { get; set; } //Set of custom images of 1x, 2x and 4x sizes for the reward. Can be null if no images have been uploaded.
        public Image default_image { get; set; } //Set of default images of 1x, 2x and 4x sizes for the reward.
        public GlobalCooldown global_cooldown { get; set; } //Whether a cooldown is enabled and what the cooldown is in seconds.
        public string cooldown_expires_at { get; set; } //Timestamp of the cooldown expiration. null if the reward isn’t on cooldown.
        public int redemptions_redeemed_current_stream { get; set; } //The number of redemptions redeemed during the current live stream. Counts against the max_per_stream limit. null if the broadcasters stream isn’t live or max_per_stream isn’t enabled.
    }
    public class ChannelPointsCustomRewardRemove : ChannelPointsCustomRewardUpdate{}
    public class ChannelPointsCustomRewardAdd : ChannelPointsCustomRewardUpdate{}
}