namespace TwitchEventSub.Types
{
    public class DropEntitlementGrant : Event
    {
        public string id { get; set; } //Individual event ID, as assigned by EventSub. Use this for de-duplicating messages.
        public EntitlementObject[] data { get; set; }

        public class EntitlementObject
        {
            public string organization_id { get; set; } //The ID of the organization that owns the game that has Drops enabled.
            public string category_id { get; set; } //Twitch category ID of the game that was being played when this benefit was entitled.
            public string category_name { get; set; } //The category name.
            public string campaign_id { get; set; } //The campaign this entitlement is associated with.
            public string user_id { get; set; } //Twitch user ID of the user who was granted the entitlement.
            public string user_name { get; set; } //The user display name of the user who was granted the entitlement.
            public string user_login { get; set; } //The user login of the user who was granted the entitlement.
            public string entitlement_id { get; set; } //Unique identifier of the entitlement. Use this to de-duplicate entitlements.
            public string benefit_id { get; set; } //Identifier of the Benefit.
            public string created_at { get; set; } //UTC timestamp in ISO format when this entitlement was granted on Twitch.
        }
    }
}