using System;
using System.Collections.Generic;

namespace TwitchEventSub.Types.EventSubSubscription
{
    public class Request
    {
        ///<summary>
        ///use one of SubscribableTypes
        ///</summary>
        public string type { get; set; }
        public string version { get; set; }
        public Conditions.Condition condition { get; set; }
        public Transport transport { get; set; }
    }
    public class Transport
    {
        public TransportMethod method { get; set; } //The transport method. Supported values: webhook.
        public Uri callback { get; set; } //The callback URL where the notification should be sent. Must use https. Must use port 443.
        public string secret { get; set; } //The secret used for verifying a signature.
    }
    public enum TransportMethod { webhook }
}