namespace TwitchEventSub.Types.Poll
{
    public class PollEvent : Event
    {
        public string id { get; set; } //ID of the poll.
        public string broadcaster_user_id { get; set; } //The requested broadcaster ID.
        public string broadcaster_user_login { get; set; } //The requested broadcaster login.
        public string broadcaster_user_name { get; set; } //The requested broadcaster display name.
        public string title { get; set; } //Question displayed for the poll.
        public PollChoice[] choices { get; set; } //An array of choices for the poll.
        public VotingMethod bits_voting { get; set; } //The Bits voting settings for the poll.
        public VotingMethod channel_points_voting { get; set; } //The Channel Points voting settings for the poll.
        public string started_at { get; set; } //The time the poll started.
    }
    public class ChannelPollBegin : PollEvent
    {
        public string ends_at { get; set; } //The time the poll will end.
    }
    public class ChannelPollProgress : PollEvent
    {
        public string ends_at { get; set; } //The time the poll will end.
    }
    public class ChannelPollEnd: PollEvent
    {
        public ChannelPollStatus status { get; set; } //The status of the poll. Valid values are completed, archived, and terminated.
        public string ended_at { get; set; } //The time the poll ended.
    }

    public enum ChannelPollStatus { completed, archived, terminated }

}