namespace TwitchEventSub.Types.Prediction
{
    public class ChannelPredictionProgress : Event
    {
        public string id { get; set; } //Channel Points Prediction ID.
        public string broadcaster_user_id { get; set; } //The requested broadcaster ID.
        public string broadcaster_user_login { get; set; } //The requested broadcaster login.
        public string broadcaster_user_name { get; set; } //The requested broadcaster display name.
        public string title { get; set; } //Title for the Channel Points Prediction.
        public Outcome[] outcomes { get; set; } //An array of outcomes for the Channel Points Prediction. Includes top_predictors.
        public string started_at { get; set; } //The time the Channel Points Prediction started.
        public string locks_at { get; set; } //The time the Channel Points Prediction will automatically lock.
    }
    public class ChannelPredictionBegin : ChannelPredictionProgress {}
    public class ChannelPredictionLock : ChannelPredictionProgress {}
    public class ChannelPredictionEnd : ChannelPredictionProgress
    {
        public string winning_outcome_id { get; set; } //docs say it's a string.
    }
}